/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/

#ifndef KYRECT
#define KYRECT

class KYPoint {
public:
	long x,y;
	KYPoint(){
		x=0;
		y=0;
	}
	void Set(long nx,long ny){
		x=nx;
		y=ny;
	}
	void  operator = (KYPoint pt){
		x=pt.x;
		y=pt.y;
	}
	KYPoint operator + (KYPoint pt){
		KYPoint tmp;
		tmp.x = x + pt.x;
		tmp.y = y + pt.y;
		return tmp;
	}
	void operator += (KYPoint pt){
		x += pt.x;
		y += pt.y;
	}

};
class KYRect {
public:
	long top,left,right,bottom;
	KYRect(){
		top=0;
		right =0;
		left=0;
		bottom = 0;
	}
	void SetRect(long l,long t,long r,long b){
		top = t;
		right=r;
		bottom = b;
		left =l;
	}
	void OffsetRect(long x,long y){
		left +=x;
		right +=x;
		top += y;
		bottom +=y;
	}
	void  operator = (KYRect rc){
		left = rc.left;
		right = rc.right;
		top = rc.top;
		bottom = rc.bottom;
	}
	KYRect operator + (KYRect rc){
		KYRect tmp;
		tmp.left = left + rc.left;
		tmp.right = right + rc.right;
		tmp.top = top + rc.top;
		tmp.bottom  = bottom + rc.bottom;
		return tmp;
	}
	void operator += (KYRect rc){
		left += rc.left;
		right += rc.right;
		top += rc.top;
		bottom += rc.bottom;
	}
	void operator *= (float percentbigger){
		//get the center
		//scale the rectangle around the center
		int cx,cy,w,h,hw,hh;
		float nhw,nhh;

		w = Width();
		h = Height();

		hw = w>>1;
		hh = h>>1;

		cx = hw + left;
		cy = hh + top;

		nhw = ((float)hw)*percentbigger;
		nhh = ((float)hh)*percentbigger;
		hw = (int)nhw;
		hh = (int)nhh;
		left  = cx - hw;
		right  = cx + hw;
		top = cy - hh;
		bottom = cy + hh;
	}
	long Width(){return right-left;}
	long Height(){return bottom-top;}
	void SetSize(long w, long h){
		right = left + w;
		bottom = top + h;
	}
	bool InRect(int x,int y){
		if((x > left) && (x < right) && (y > top) && (y < bottom)) return true;
		return false;
	}
	//operator = ()
};
#endif
