#include <allegro.h>

#include "musicsample.h"
#include "mmdd.h"
#include "kybitmap.h"
#include "log.h"

#include "vector2d.h"
#include "math.h"
#define MAX_TURN  20
#define TILESIZE 32
#define  tilegrass1 2016
#define tilegrass2 1024
#define tileb1 63488
#define tileb2 32768
#define tileb3 31
#define tileb4 16
#define tiletrack1 0
#define MAXSPEED  7
#define MAXGAS  100
#define TRACKLEN  600 
#define PI 3.1415926535
#define PIDIV180  PI / 180 //rad per degree
#define RADPERDEG  PIDIV180 //rad per degree
#define DEGPERRAD  180 / PI //degree per rad
#define PIDIV2 1.570796327
#define PIMUL2 6.283185307
#define FINISHLINE 584
#define numentrys 1024
#define stepprecfact 2.844444444f
float sinlook[numentrys],coslook[numentrys];
//float SIN(float n);
//float COS(float n);
#define SIN(n)(sinlook[int(n*stepprecfact)])
#define COS(n)(coslook[int(n*stepprecfact)])

WaveSample skidsound;
WaveSample enginesound;
bool   aifl       = false;
struct pathpt{
       int x,y;       
};
pathpt aipath[]= {
       {1,7},{26,7},{33,9},{50,5},{55,7},
       {68,8},{75,4},{87,3},{93,8},{96,8},
       {104,12},{115,5},{122,5},{126,4},{140,6},
       {144,5},{149,8},{171,9},{187,5},{202,7},
       {215,5},{235,9},{243,6},{251,7},{261,4},
       {282,7},{289,6},{312,7},{331,5},{346,12},
       {354,12},{363,12},{368,5},{372,3},{386,14},
       {409,7},{438,9},{457,8},{466,6},{479,2},
       {501,12},{514,10},{524,5},{597,7}         
};
int numpathpt = 44;

void Build_Look_Up_Tables(void){
	Log("building lookup tables");
	 double unit = ( double)(PI * 2.0f ) / ( double) numentrys;
	for (unsigned short  i = 0 ; i < numentrys ; i++)
    {
         double Degree = ( double)i;
		coslook[i] = float(cos(unit * Degree));
		sinlook[i] = float(sin(unit * Degree));
    }
} // end Build_Look_Up_Tables


// to do, Lock to speed
// music
//other players
//vector moving

volatile long curtimems;
int Iteration();
void ResetGame();
int gamemode=0;  // 0 is splash , 1 is running , 2 is over(win),3 is over (lose)
float gtrackpos = 0;

void GameOver(int mode); // 0 is lose , 1 is win 

void DegtoVec(Vector2d *vec,float dist,float angle){ // angle in deg.
	//convert angle and dist to x -y plane orbit
	//'center->Wx
	float xp,yp;
	xp = dist * COS(angle);
	yp = dist * SIN(angle);
//	Log("xp %f, yp %f",xp,yp);
	vec->x = xp;
	vec->y = yp;
}
void WrapAngle(float *deg){
     if(*deg > 359.99)
     {
       *deg = 0.0f;
     }
     if(*deg < 0.0f){
         *deg = 359.0f;    
     }
}



/* timer callback */


void timer_callback(void)
{
   curtimems++;
   
   Iteration();
}
END_OF_FUNCTION(timer_callback);

KYBitmap bmGasmeter;
KYBitmap bmSpedometer;
KYBitmap splashbm;

class Track{
      public:
      KYRect curpos; // the current position of the track
      KYBitmap trackbm;
      KYBitmap tiles[10];

      int gas;
      int nitro;
      void LoadTrack(){
           trackbm.Load(".\\art\\track1.bmp");     
           tiles[0].Load(".\\art\\grass1.bmp");     
           tiles[1].Load(".\\art\\grass2.bmp");     
           tiles[2].Load(".\\art\\b1.bmp");     
           tiles[3].Load(".\\art\\b2.bmp");     
           tiles[4].Load(".\\art\\b3.bmp");     
           tiles[5].Load(".\\art\\b4.bmp");     
           tiles[6].Load(".\\art\\track.bmp");     
      }
      void DisplayTrack(int x){
           // divide x by 32 to get the tile position
           int xt = x>>5;
           int xc,yc;
           int pix;
		   int b;
//		   int offset = (x - xt)%TILESIZE ;
           int offset = x %TILESIZE ;
		   offset *= -1;
		 //  Log("offset %d",offset);
		   KYRect rc;
		   if(x>600-21){x=600-21;}
           for (xc = xt ; xc <xt+21;xc++){
               for (yc = 0; yc< 15;yc++){
 
                      pix = getpixel(trackbm.m_pSurf,xc,yc);
					  b = getb(pix);
               //       Log("Getting pixel %d %d",xc,yc);
					  rc.SetRect((xc-xt)*TILESIZE+offset,yc*TILESIZE,((xc-xt)*TILESIZE)+32+offset,(yc*TILESIZE)+32);
				//	  Log("%d ,%d , pix is %d",xc  *32,yc*32,pix);
			
                      switch(pix){
                           case tilegrass1:
                                tiles[0].StretchBestFit(&rc,255);
                                break;    
                           case tilegrass2:
                                tiles[1].StretchBestFit(&rc,255);
                                break;           
                           case tileb1:
                                tiles[2].StretchBestFit(&rc,255);
                                break;           
                           case tileb2:
                                tiles[3].StretchBestFit(&rc,255);
                                break;           
                           case tileb3:
                                tiles[4].StretchBestFit(&rc,255);
                                break; 
                           case tileb4:
                                tiles[5].StretchBestFit(&rc,255);
                                break;
                           case tiletrack1:
                                tiles[6].StretchBestFit(&rc,255);
                                break;           
                                           
                                          

                      }					  
                      
					  
               }    
           }
      }   
      Track(){
              curpos.SetRect(0,0,20,15);        
      }   
};
class Player{
      public:
      Vector2d vec;  // direction only            
      int aipathidx;
      Player(){
               lives = 3;
               angle = 0.0f;
               xpos = 64;
               ypos = 220;
               gas = 100;
               vec.Vector2d::Set(1,0); // set the forward direction
               usingnitro = false;
               nitrotimer =0;
               aipathidx   = 0 ; // ai's start at first point
      }
      ~Player(){}
      float xpos;
      int gas;
      float ypos;
      float angle;
      bool usingnitro;
      int nitrotimer;
      int turnspeed ;// how fast can the player turn
      float speed ; // ramp it up using a sin wav 
      KYBitmap m_playerbm;
    //  KYBitmap m_playerdb; // double buffer for rotation
      int playerstate; // state of the player
      int lives;      
      void TurnLeft(){
           angle -= 2.0f;
           WrapAngle(&angle);
           DegtoVec(&vec,1,angle);           
      }
      void TurnRight(){
           angle += 2.0f;
           WrapAngle(&angle);
           DegtoVec(&vec,1,angle);           
      }
      void LoadPlayer(){
          m_playerbm.Load(".\\art\\player.bmp");  
         // m_playerdb.m_pSurf = create_bitmap((int )(m_playerbm.Width()*1.4),(int)(m_playerbm.Height()*1.4));    
      }
      void DrawPlayer(){
           KYRect rc;
         //  clear_bitmap(m_playerdb.m_pSurf,makecol(255,0,255));
        //   rc.SetRect(0,0,m_playerbm.Width(),m_playerbm.Height());

           rc.SetRect(40,(long)ypos,40+32,(long)ypos+32);
         // m_playerdb.StretchBestFitTrans(&rc,255); 
           m_playerbm.StretchBestFitRotated(TheScreen->backbuffer,&rc,angle);         
        // m_playerbm.StretchBestFitTrans(&rc,255); 
      }
};


Player Player1;
Player AI[5]; // 5 other ai players

Track thetrack;
KYBitmap bmNitro;
KYBitmap bmGas;
KYBitmap bmPlayerwon;
KYBitmap bmPlayerlost;
KYRect arrayGas[20]; // 10 gas powerups
bool   arrayGasvis[20]; // visible
KYRect arrayNitro[20]; // 10 nitro
bool   arrayNitrovis[20];
void DrawPlayerGas(){
   // char temp[256];
  //  sprintf(temp,"Gas Remaining: %d",Player1.gas);  
  ///  textout(TheScreen->backbuffer, font, temp, 1, 1, 20);
//       textout(TheScreen->backbuffer, font, "Press ESCape to quit.", 1, 12, 11);
    KYRect rc;
    rc.SetRect(64,0,128,64);
    bmGasmeter.StretchBestFitTrans(&rc,0);
    int x2,y2;
    float xp,yp;
    float angle;
    x2 = 0,y2=0;
    angle = (float)Player1.gas * (359 /MAXGAS)+ (359 - 90) ;
//    angle = Player1.speed * (359 /MAXSPEED) + (359 - 90) ;    
//    angle = 359 - angle;
    if(angle > 359){
             angle -= 359;
    }    

    
	xp = 30 * COS(angle);
	yp = 30 * SIN(angle);
	x2 = xp + 64 +32;
    y2 = yp + 32;	    

    line(TheScreen->backbuffer, 64+32, 32,x2,y2, makecol(255,0,0));
    line(TheScreen->backbuffer, 64+33, 32,x2,y2, makecol(255,0,0));
    line(TheScreen->backbuffer, 64+31, 32,x2,y2, makecol(255,0,0));


          
}
void DrawPlayerSpeed(){
   // char temp[256];
   // sprintf(temp,"Speed : %d",Player1.speed);  
   // textout(TheScreen->backbuffer, font, temp, 1, 12, 20);
    KYRect rc;
    float xp,yp;
    float angle;
    
    rc.SetRect(0,0,64,64);
    bmSpedometer.StretchBestFitTrans(&rc,0);
    Log("Speed %d",Player1.speed);
    angle = Player1.speed * (359 /MAXSPEED) + (359 - 90) ;
    if(angle > 359){
             angle -= 359;
    }
    
    int x2,y2;
    x2 = 10;
    y2 = 10;
    
	xp = 30 * COS(angle);
	yp = 30 * SIN(angle);
	
	x2 = xp + 32;
    y2 = yp + 32;
//	Log("xp %f, yp %f",xp,yp);
	
    line(TheScreen->backbuffer, 32, 32,x2,y2, makecol(255,0,0));
    line(TheScreen->backbuffer, 33, 32,x2,y2, makecol(255,0,0));
    line(TheScreen->backbuffer, 31, 32,x2,y2, makecol(255,0,0));
     
}
void InitPowerups(){
     // load the powerup bitmaps
     bmGas.Load(".\\art\\gas.bmp");
     bmNitro.Load(".\\art\\nitro.bmp");
     srand(clock());
     int xp,yp;
       int pix;
     for(int i=0;i<20;i++){
            //choose a world position for these
         xp = rand()%500 +50;
         //pix = tiletrack1;
        // while (pix != tiletrack1){         
         yp = rand()%6 +5;
          //        pix = getpixel(thetrack.trackbm.m_pSurf,xp,yp);                 
        // }
         xp =xp * TILESIZE;
         yp = yp *TILESIZE;
         arrayGas[i].SetRect(xp,yp,xp+30,yp+30);
         arrayGasvis[i] = true;
         
         xp = rand()%500 +50;
         yp = rand()%7 +4;
         //pix = tiletrack1;
         while (pix != tiletrack1){         
                  yp = rand()%15;
                  pix = getpixel(thetrack.trackbm.m_pSurf,xp,yp);                 
         }
         
         xp =xp * TILESIZE;
         yp = yp *TILESIZE;
         arrayNitro[i].SetRect(xp,yp,xp+30,yp+30);
         arrayNitrovis[i] = true;
         
     }
}
void DrawPowerups(){
//     Get      the vsisble portion
//of the screen
//translate the powerup positions to screen pos.
//draw them
KYRect rc;
       for(int i =0 ;i <20 ;i++){
          if(arrayGasvis[i]) {
             rc = arrayGas[i];
             rc.OffsetRect((int)-Player1.xpos,0);     
             bmGas.StretchBestFitTrans(&rc,0);     
          }
          if(arrayNitrovis[i]) {
             rc = arrayNitro[i];
             rc.OffsetRect((int)-Player1.xpos,0);     
             bmNitro.StretchBestFitTrans(&rc,0);     
          }
          
       }
}
 void GetInput(){
     //read the keys
     if(key[KEY_ENTER]){
        gamemode  = 1;//
        //reset game                  
        ResetGame ();       
        //play as sopunf 
     }
     if(key[KEY_SPACE]){
           Player1.speed += .5;     
           if(Player1.usingnitro){
               if(Player1.speed > MAXSPEED *2 ){
                    Player1.speed = MAXSPEED *2;                 
               }                                                              
           }else{
               if(Player1.speed > MAXSPEED ){
                    Player1.speed = MAXSPEED;                 
               }                            
           }
     }
     if(key[KEY_LCONTROL]){
           Player1.speed -= .5;     
           if(Player1.speed < 0  ){
                Player1.speed = .5;                 
           }                            
     }

     if(key[KEY_LEFT]){
       //play a sound 
         Player1.TurnLeft();
         if(Player1.speed >2 ){
                  skidsound.Play();
         }
     }
     if(key[KEY_RIGHT]){             
        //play a sound           
         Player1.TurnRight();
         if(Player1.speed >2 ){
                  skidsound.Play();
         }
     }
     if((curtimems % 20) == 0){
       enginesound.Play();              
     }
     Vector2d v = Player1.vec;
     v = v * Player1.speed ;
     Player1.xpos += v.x;
     Player1.ypos += v.y;
}

void UpdatePositions(){
     //based on the new input , update the player position
     //update the ai positions
     Player1.xpos += Player1.speed;
  //    check to see if the player got a powerup
  //check gas collision
  for (int i =0;i<10;i++)
  {
      if(arrayGasvis[i])
      {
          //Log("player x%d,y %d pos ",Player1.xpos,Player1.ypos );
          //Log("Rect l %d,t %d",arrayGas[i].left,arrayGas[i].top);              
          if(arrayGas[i].InRect((int)Player1.xpos+40+16,(int)Player1.ypos+15))
          {
            Player1.gas += 10;
            if(Player1.gas >MAXGAS){
                Player1.gas = MAXGAS;
            }
            arrayGasvis[i] = false;
          }     
          if(arrayGas[i].InRect((int)Player1.xpos+40+16,(int)Player1.ypos))
          {
            Player1.gas += 10;
            if(Player1.gas >MAXGAS){
                Player1.gas = MAXGAS;
            }
            arrayGasvis[i] = false;
          }     
          if(arrayGas[i].InRect((int)Player1.xpos+40+16,(int)Player1.ypos+32))
          {
            Player1.gas += 10;
            if(Player1.gas >MAXGAS){
                Player1.gas = MAXGAS;
            }
            arrayGasvis[i] = false;
          }     
          if(arrayGas[i].InRect((int)Player1.xpos+40,(int)Player1.ypos+15))
          {
            Player1.gas += 10;
            if(Player1.gas >MAXGAS){
                Player1.gas = MAXGAS;
            }
            arrayGasvis[i] = false;
          }     
          if(arrayNitro[i].InRect((int)Player1.xpos+40+16,(int)Player1.ypos))
          {
            
            arrayNitrovis[i] = false;
            Player1.usingnitro = true;
            Player1.nitrotimer = 100;
            Player1.speed *=2;
          }                   
                        
      }    
  }
  //check nitro collisons
  //check grass collisions
  int pix;
  
  pix = getpixel(thetrack.trackbm.m_pSurf,(int)Player1.xpos>>5 ,(int)Player1.ypos >>5);  
  if (pix == tilegrass1 || pix == tilegrass2){
     //slow down the speed        
     Player1.speed = Player1.speed - 2;
     if(Player1.speed <1)Player1.speed = 1;
  }
  if(Player1.ypos > 450) Player1.ypos = 450;
  if(Player1.ypos < 0) Player1.ypos = 0;
  //check to see if player is out of gas
  if(curtimems % 15 == 0)
    Player1.gas -= 1;
  
  if(Player1.usingnitro){
      Player1.nitrotimer --;
      if(Player1.nitrotimer <0){
      Player1.nitrotimer  = 0;
      Player1.usingnitro =false;                      
      }                       
  }
  if(Player1.gas <= 0){
      Log("Game Over out of gas");
      GameOver(0);               
  }
  if(Player1.xpos > FINISHLINE * TILESIZE && !aifl){ // player wins (if he's first)
      GameOver(1);            
  }else if(aifl){
     GameOver(0);                    
  }
}
void GameOver(int mode){ // 0 is lose , 1 is win 
     gamemode = mode +2;//
}
void InitializeGame(){
     Player1.LoadPlayer();
     for (int i=0;i<5;i++){
         AI[i].LoadPlayer();    

     }
     thetrack.LoadTrack();
     bmGasmeter.Load(".\\art\\gasmeter.bmp");
     bmSpedometer.Load(".\\art\\sped.bmp");
     splashbm.Load(".\\art\\splash.bmp");     
     bmPlayerwon.Load(".\\art\\playerwin.bmp");     
     bmPlayerlost.Load(".\\art\\playerlose.bmp");     
     
//KYBitmap ;
     
     //load the track
     //load the tiles
     //initilize the powerup positions
     
}
void UpdateAI(){
     // to update the ai,
     // find ther next point, mocve towards it
     int np; // next point 
     int pix; 
     for (int i=0;i<5;i++){
         np = AI[i].aipathidx +1;
         if(np >= numpathpt)np = numpathpt;
         //now the mov func.
         //always try to speed up
         AI[i].speed += (float)(rand() % 4)/10;
//         Log("AI %d speed %d",i,AI[i].speed);
         if(AI[i].speed > MAXSPEED * 2)AI[i].speed = MAXSPEED*2; // limit the speed
         AI[i].xpos += AI[i].speed  - 3 +rand()%3 ;
         // inc or dec the y
         if(aipath[AI[i].aipathidx].y * TILESIZE > AI[i].ypos){
            AI[i].ypos ++;
            AI[i].ypos += rand()%3 ;                     
         }else{
            AI[i].ypos --;                        
            AI[i].ypos -= rand()%3 ;                                 
         }
         
         if(AI[i].xpos >= aipath[AI[i].aipathidx].x *TILESIZE){
               AI[i].aipathidx = np; // move to the next position        
         }
          pix = getpixel(thetrack.trackbm.m_pSurf,(int)AI[i].xpos>>5 ,(int)AI[i].ypos >>5);  
          if (pix == tilegrass1 || pix == tilegrass2){
             //slow down the speed        
             AI[i].speed -= - 2;
             if(AI[i].speed <1)AI[i].speed = 1;
          }
               
          if(AI[i].xpos > FINISHLINE * TILESIZE){
             aifl = true;           
          }     
     }
     
}
void DrawAI(){
     KYRect rc;
     int xp;
     int yp;
     for (int i=0;i<5;i++)     {
         xp = AI[i].xpos;
         yp = AI[i].ypos;         
     //    Log("AI %d pos x %d, y %d",i,xp,yp);
         rc.SetRect(xp,yp,xp+TILESIZE,yp +TILESIZE);
         rc.OffsetRect((int)-Player1.xpos,0);     
         AI[i].m_playerbm.StretchBestFitTrans(&rc,0);                 
     }
}

int Iteration(){ // one iteration of the game loop
    GetInput();
     KYRect rc;    
    if(gamemode == 0){//splash       
        //display the splash b,                         
        thetrack.DisplayTrack((int)gtrackpos);                
        gtrackpos++;
        if(gtrackpos>600)gtrackpos=0;
         rc.SetRect(270,200,270+300,400);
         splashbm.StretchBestFitTrans(&TheScreen->rcbackbuff,0);        
    }else if (gamemode == 1){
        UpdatePositions();
        //update music
        thetrack.DisplayTrack((int)Player1.xpos);                        
        DrawPowerups();
        Player1.DrawPlayer();
        UpdateAI();
        DrawAI();
        DrawPlayerGas();
        DrawPlayerSpeed();
    }else if (gamemode == 2 ){ 
          rc.SetRect(0,0,640,480);
          bmPlayerlost.StretchBestFitTrans(&rc,0);
          
    }else if (gamemode == 3 ){ //player won
          rc.SetRect(0,0,640,480);

          bmPlayerwon.StretchBestFitTrans(&rc,0);          
    }
    TheScreen->PageFlip();      
    
    if(key[KEY_ESC])return -1;
    return 0;
}
void ExitGame(){
     //cleanup code here
     //destory bitmaps
     //uninstall timer
    TheScreen-> Cleanup(true);
    allegro_exit();     
     exit(1);
}
void ResetGame(){ // restart the game here
     //reset player 1 positon
     // reset powerups
      InitPowerups();
      Player1.xpos = 40;
      Player1.gas = MAXGAS;
      Player1.speed = 0;
      aifl       = false;
      for (int i=0;i<5;i++){
            AI[i].xpos = 60;
            AI[i].ypos = (rand()%5 + 5) * TILESIZE;                
            AI[i].aipathidx =0;//set to the forst pathidx
            AI[i].speed = 0;
          }
           
}
int main() 
{ 
 // Initialize Allegro.        
 allegro_init();      
// SetLogPath("c:\\projects\\tins\\");

 // Set the resolution to 640 by 480 with SAFE autodetection.
 //set_gfx_mode(GFX_SAFE, 640, 480, 0, 0);
 TheScreen->Initialize(640,480,16,640,480,true);
 TheScreen->ClsBack(makecol(255,255,255));
	if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, 0) != 0) {
		Log("could not install sound");
		install_sound (DIGI_NONE, MIDI_NONE, NULL);
	}else{
		set_volume(64,64);
	}
    skidsound.Load(".\\sound\\skid.wav");
    enginesound.Load(".\\sound\\engine.wav");
	LOCK_FUNCTION(timer_callback);
	LOCK_VARIABLE(curtimems);
    install_keyboard();
	//install_int(timer_callback,MSEC_TO_TIMER(1));
    text_mode(-1);
    InitializeGame();
    ResetGame();
    Build_Look_Up_Tables();	
	install_int(timer_callback,50);  // lock onto 20 fps    
 // Looping until the ESCape key is pressed.
   while(! key[KEY_ESC]){
            poll_keyboard(); // This shouldn't be necessary in Windows. 
   }
 // Exit program.
 ExitGame();
 return 0;     
}     

// Some Allegro magic to deal with WinMain().
END_OF_MAIN();
