/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/
#ifndef KYMAERA_SOUNDMANAGER
#include "allegro.h"
#include "almp3.h"
#include "alogg.h"
#include "listitem.h"
#include "eventmanager.h"
#include "singleton.h"
#include "musicsample.h"





struct soundentry{
	EventCodes event;
	//string soundfile;
	char soundfile[256];
	void Save(CMarkupSTL *xmldoc);
	void Load(CMarkupSTL *xmldoc);
};

class SoundManager:public Singleton<SoundManager>
{
public:
	List m_SoundEntries;
	List m_Mp3PlayList;
	string  m_Mp3PlayListFileName;
	Listitem *m_curMP3;
	string m_SoundMapFile;//what file did we load this from?

	bool m_playmp3; // show we play the playlist
	bool m_mp3random;// random playorder or sequential
	SoundManager(void);
	~SoundManager(void);
	bool Startup();
	void Shutdown();
	void Pause();
	void Resume();
	void Update();
	void Release(); // the list
	void Play(char *filename,int channel);
	void CreateDefault();
	void PlayEventSound(EventCodes evt);
	void ReleaseMP3PlayList(); // the list
	void LoadMP3PlayList(string filename);
	void Load(string filename);
	void Save(string filename);
	void NextSong();
	void PreviousSong();
	void Init();
	SoundFile *strm1;	// wav file playing
	SoundFile *strm2;	// mp3 or ogg file playing
};

#define g_SndMgr SoundManager::GetInstance()
#endif

